package dev.shadowsoffire.apotheosis.adventure.socket.gem;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import dev.shadowsoffire.apotheosis.adventure.affix.AffixHelper;
import dev.shadowsoffire.apotheosis.adventure.loot.LootCategory;
import dev.shadowsoffire.apotheosis.adventure.loot.LootRarity;
import dev.shadowsoffire.apotheosis.adventure.loot.RarityRegistry;
import dev.shadowsoffire.apotheosis.adventure.socket.gem.Gem;
import dev.shadowsoffire.apotheosis.adventure.socket.gem.GemItem;
import dev.shadowsoffire.apotheosis.adventure.socket.gem.GemRegistry;
import dev.shadowsoffire.apotheosis.adventure.socket.gem.bonus.GemBonus;
import dev.shadowsoffire.placebo.codec.CodecProvider;
import dev.shadowsoffire.placebo.reload.DynamicHolder;
import it.unimi.dsi.fastutil.objects.ObjectArrayList;
import java.util.List;
import java.util.Map;
import java.util.Optional;
import java.util.UUID;
import java.util.function.BiConsumer;
import java.util.function.Consumer;
import java.util.function.Function;
import javax.annotation.Nullable;
import net.minecraft.core.BlockPos;
import net.minecraft.network.chat.Component;
import net.minecraft.server.level.ServerPlayer;
import net.minecraft.world.InteractionResult;
import net.minecraft.world.damagesource.DamageSource;
import net.minecraft.world.entity.Entity;
import net.minecraft.world.entity.EquipmentSlot;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.entity.MobType;
import net.minecraft.world.entity.ai.attributes.Attribute;
import net.minecraft.world.entity.ai.attributes.AttributeModifier;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.entity.projectile.AbstractArrow;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.context.UseOnContext;
import net.minecraft.world.item.enchantment.Enchantment;
import net.minecraft.world.level.LevelAccessor;
import net.minecraft.world.level.block.state.BlockState;
import net.minecraft.world.level.storage.loot.LootContext;
import net.minecraft.world.phys.HitResult;

public final class GemInstance extends Record {
  private final DynamicHolder<Gem> gem;
  
  private final LootCategory cat;
  
  private final ItemStack gemStack;
  
  private final DynamicHolder<LootRarity> rarity;
  
  public GemInstance(DynamicHolder<Gem> gem, LootCategory cat, ItemStack gemStack, DynamicHolder<LootRarity> rarity) {
    this.gem = gem;
    this.cat = cat;
    this.gemStack = gemStack;
    this.rarity = rarity;
  }
  
  public final String toString() {
    // Byte code:
    //   0: aload_0
    //   1: <illegal opcode> toString : (Ldev/shadowsoffire/apotheosis/adventure/socket/gem/GemInstance;)Ljava/lang/String;
    //   6: areturn
    // Line number table:
    //   Java source line number -> byte code offset
    //   #53	-> 0
    // Local variable table:
    //   start	length	slot	name	descriptor
    //   0	7	0	this	Ldev/shadowsoffire/apotheosis/adventure/socket/gem/GemInstance;
  }
  
  public final int hashCode() {
    // Byte code:
    //   0: aload_0
    //   1: <illegal opcode> hashCode : (Ldev/shadowsoffire/apotheosis/adventure/socket/gem/GemInstance;)I
    //   6: ireturn
    // Line number table:
    //   Java source line number -> byte code offset
    //   #53	-> 0
    // Local variable table:
    //   start	length	slot	name	descriptor
    //   0	7	0	this	Ldev/shadowsoffire/apotheosis/adventure/socket/gem/GemInstance;
  }
  
  public final boolean equals(Object o) {
    // Byte code:
    //   0: aload_0
    //   1: aload_1
    //   2: <illegal opcode> equals : (Ldev/shadowsoffire/apotheosis/adventure/socket/gem/GemInstance;Ljava/lang/Object;)Z
    //   7: ireturn
    // Line number table:
    //   Java source line number -> byte code offset
    //   #53	-> 0
    // Local variable table:
    //   start	length	slot	name	descriptor
    //   0	8	0	this	Ldev/shadowsoffire/apotheosis/adventure/socket/gem/GemInstance;
    //   0	8	1	o	Ljava/lang/Object;
  }
  
  public DynamicHolder<Gem> gem() {
    return this.gem;
  }
  
  public LootCategory cat() {
    return this.cat;
  }
  
  public ItemStack gemStack() {
    return this.gemStack;
  }
  
  public DynamicHolder<LootRarity> rarity() {
    return this.rarity;
  }
  
  public static dev.shadowsoffire.apotheosis.adventure.socket.gem.GemInstance EMPTY = new dev.shadowsoffire.apotheosis.adventure.socket.gem.GemInstance(GemRegistry.INSTANCE.emptyHolder(), LootCategory.NONE, ItemStack.f_41583_, RarityRegistry.INSTANCE.emptyHolder());
  
  public static dev.shadowsoffire.apotheosis.adventure.socket.gem.GemInstance socketed(ItemStack socketed, ItemStack gemStack) {
    return socketed(LootCategory.forItem(socketed), gemStack);
  }
  
  public static dev.shadowsoffire.apotheosis.adventure.socket.gem.GemInstance socketed(LootCategory category, ItemStack gemStack) {
    DynamicHolder<Gem> gem = GemItem.getGem(gemStack);
    DynamicHolder<LootRarity> rarity = AffixHelper.getRarity(gemStack);
    if (gem.isBound() && rarity.isBound())
      rarity = RarityRegistry.INSTANCE.holder((CodecProvider)((Gem)gem.get()).clamp((LootRarity)rarity.get())); 
    return new dev.shadowsoffire.apotheosis.adventure.socket.gem.GemInstance(gem, category, gemStack, rarity);
  }
  
  public static dev.shadowsoffire.apotheosis.adventure.socket.gem.GemInstance unsocketed(ItemStack gemStack) {
    DynamicHolder<Gem> gem = GemItem.getGem(gemStack);
    DynamicHolder<LootRarity> rarity = AffixHelper.getRarity(gemStack);
    if (gem.isBound() && rarity.isBound())
      rarity = RarityRegistry.INSTANCE.holder((CodecProvider)((Gem)gem.get()).clamp((LootRarity)rarity.get())); 
    return new dev.shadowsoffire.apotheosis.adventure.socket.gem.GemInstance(gem, LootCategory.NONE, gemStack, rarity);
  }
  
  public boolean isValidUnsocketed() {
    return (this.gem.isBound() && this.rarity.isBound());
  }
  
  public boolean isValid() {
    return (isValidUnsocketed() && ((Gem)this.gem.get()).getBonus(this.cat, (LootRarity)this.rarity.get()).isPresent());
  }
  
  public boolean isMaxRarity() {
    return (rarity().get() == ((Gem)this.gem.get()).getMaxRarity());
  }
  
  public boolean canApplyTo(ItemStack stack) {
    return ((Gem)this.gem.get()).canApplyTo(stack, this.gemStack, (LootRarity)this.rarity.get());
  }
  
  public void addModifiers(EquipmentSlot slot, BiConsumer<Attribute, AttributeModifier> map) {
    for (EquipmentSlot itemSlot : this.cat.getSlots()) {
      if (itemSlot == slot)
        ifPresent(b -> b.addModifiers(this.gemStack, (LootRarity)this.rarity.get(), map)); 
    } 
  }
  
  public List<UUID> getUUIDs() {
    return GemItem.getUUIDs(this.gemStack);
  }
  
  public Component getSocketBonusTooltip() {
    return (Component)map(b -> b.getSocketBonusTooltip(this.gemStack, (LootRarity)this.rarity.get())).orElse(Component.m_237113_("Invalid Gem Category"));
  }
  
  public int getDamageProtection(DamageSource source) {
    return ((Integer)map(b -> Integer.valueOf(b.getDamageProtection(this.gemStack, (LootRarity)this.rarity.get(), source))).orElse(Integer.valueOf(0))).intValue();
  }
  
  public float getDamageBonus(MobType creatureType) {
    return ((Float)map(b -> Float.valueOf(b.getDamageBonus(this.gemStack, (LootRarity)this.rarity.get(), creatureType))).orElse(Float.valueOf(0.0F))).floatValue();
  }
  
  public void doPostAttack(LivingEntity user, @Nullable Entity target) {
    ifPresent(b -> b.doPostAttack(this.gemStack, (LootRarity)this.rarity.get(), user, target));
  }
  
  public void doPostHurt(LivingEntity user, @Nullable Entity attacker) {
    ifPresent(b -> b.doPostHurt(this.gemStack, (LootRarity)this.rarity.get(), user, attacker));
  }
  
  public void onArrowFired(LivingEntity user, AbstractArrow arrow) {
    ifPresent(b -> b.onArrowFired(this.gemStack, (LootRarity)this.rarity.get(), user, arrow));
  }
  
  @Nullable
  public InteractionResult onItemUse(UseOnContext ctx) {
    return map(b -> b.onItemUse(this.gemStack, (LootRarity)this.rarity.get(), ctx)).orElse(null);
  }
  
  public void onArrowImpact(AbstractArrow arrow, HitResult res) {
    ifPresent(b -> b.onArrowImpact(this.gemStack, (LootRarity)this.rarity.get(), arrow, res));
  }
  
  public float onShieldBlock(LivingEntity entity, DamageSource source, float amount) {
    return ((Float)map(b -> Float.valueOf(b.onShieldBlock(this.gemStack, (LootRarity)this.rarity.get(), entity, source, amount))).orElse(Float.valueOf(amount))).floatValue();
  }
  
  public void onBlockBreak(Player player, LevelAccessor world, BlockPos pos, BlockState state) {
    ifPresent(b -> b.onBlockBreak(this.gemStack, (LootRarity)this.rarity.get(), player, world, pos, state));
  }
  
  public float getDurabilityBonusPercentage(ServerPlayer user) {
    return ((Float)map(b -> Float.valueOf(b.getDurabilityBonusPercentage(this.gemStack, (LootRarity)this.rarity.get(), user))).orElse(Float.valueOf(0.0F))).floatValue();
  }
  
  public float onHurt(DamageSource src, LivingEntity ent, float amount) {
    return ((Float)map(b -> Float.valueOf(b.onHurt(this.gemStack, (LootRarity)this.rarity.get(), src, ent, amount))).orElse(Float.valueOf(amount))).floatValue();
  }
  
  public void getEnchantmentLevels(Map<Enchantment, Integer> enchantments) {
    ifPresent(b -> b.getEnchantmentLevels(this.gemStack, (LootRarity)this.rarity.get(), enchantments));
  }
  
  public void modifyLoot(ObjectArrayList<ItemStack> loot, LootContext ctx) {
    ifPresent(b -> b.modifyLoot(this.gemStack, (LootRarity)this.rarity.get(), loot, ctx));
  }
  
  private <T> Optional<T> map(Function<GemBonus, T> function) {
    return ((Gem)this.gem.get()).getBonus(this.cat, (LootRarity)this.rarity.get()).map(function);
  }
  
  private void ifPresent(Consumer<GemBonus> function) {
    ((Gem)this.gem.get()).getBonus(this.cat, (LootRarity)this.rarity.get()).ifPresent(function);
  }
}
